/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :  
Version : V1.1 beta
Date    : 27.06.2013
Author  : CAMOKAT-BETEPAHA
Company : http://umat.ru
Comments:   
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16

              PB0 -  
              PB1 -  
              PB2 -      
              PB3 -   
              PB4 -   
              PB5 -     
       
        ,
       
 ,    . 
 
      ,    
       . 

*****************************************************/

#include <tiny13a.h>
#include <delay.h>                    

#define MIN PINB.4                    //     
#define MAX PINB.3                    //    
#define ILL PINB.1                    //  : 0 -   1 -  

#define THRESHOLD 225                 //        .
                                      //    5 ,      
                                      // 10  4,7,     13,8      
                                      // 4,4 ,     255  (100 )
                                      
typedef unsigned char byte;           //    unsigned char  byte

byte volt,mode,trigmin,trigmax,voltill;          //   
byte voltmin,voltmax,third;

eeprom byte eevoltmin,eevoltmax;      //      

byte read_adc(byte adc_in)            //  ,  16     
{                                     
 unsigned int  adc_mid;
 byte a;
 adc_mid=0;
 ADMUX=adc_in|0b00100000;
 for(a=0;a<16;a++)                   //  16 
  {
   delay_us(10);
   ADCSRA|=0x40;
   while ((ADCSRA & 0x10)==0);
   ADCSRA|=0x10;
   adc_mid+=ADCH;
  }
 adc_mid/=16;                       
 return adc_mid;;
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)  //    
{                                               //   73   
 if(mode==1)                                    //  
  {
   if(OCR0A!=255)OCR0A++;                       //     -  
  }
 if(mode==0)                                    //   
  {                                              
   if(OCR0A!=0)OCR0A--;                         //     -  
  }
 if(mode==2)                                    //   (  adc0)
  {
   if(OCR0A>voltill)OCR0A--;                    //     ADC0 -  
   if(OCR0A<voltill)OCR0A++;                    //     ADC0 -  
  }
}

void Convert(void)                              //  - 
{
 voltmin=eevoltmin;                             //          .
 voltmax=eevoltmax;                             //          .
 if(voltmax>voltmin)                            //     
  {                                             //       
   third=(voltmax-voltmin)/3;                    
   voltmax-=third;
   voltmin+=third; 
  }
 if(voltmax<voltmin)voltmin=voltmax=THRESHOLD;  //                                                          
}
void main(void)                                 //     
{
PORTB=0x18;                                     //  
DDRB=0x01;

TCCR0A=0x81;                                    //     Phase correct PWM,    PB0
TCCR0B=0x04;
TIMSK0=0x02;                                    //     (73   )

ACSR=0x80;                                      //  

ADCSRA=0x86;                                    //  

Convert();                                      // 72 
                                                
#asm("sei")                                     //  

while (1)                                       //   
      { 
       volt=read_adc(1);                        //       volt
       if(volt<voltmin)mode=0;                  //    ,   
       if(volt>voltmax)                         //     :
        {
         if(ILL)                                //    :
          {
           voltill=~read_adc(0);                //        
           mode=2;                              //     
          } 
         else mode=1;                           //    -   
        }
        
       if(MIN==0)                               //    MIN 
        { 
         if(trigmin==0)                         //  
          {
           volt=read_adc(1);                    //       volt
           trigmin=1;                           //  
           eevoltmin=volt;                      //   
          }
        }
       else 
        {
         if(trigmin)                            //  
          {
           Convert();                           // -
           trigmin=0;                           //   
          }
        }
       if(MAX==0)                               //    MAX
        {
         if(trigmax==0)                         //  
          { 
           volt=read_adc(1);                    //       volt
           trigmax=1;                           //  
           eevoltmax=volt;                      //   
          }
        }
       else 
        {
         if(trigmax)                            //  
          {
           Convert();                           // -
           trigmax=0;                           //   
          }
        }
      }                                         //       
}                                               //  
